<?php
function ShowClaimsList(){
  if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента
    $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT timezone, timeformat, tpp FROM users WHERE iduser=? LIMIT 1');
    mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $timezone, $timeformat, $tpp);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
  }else{
    $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
    $tpp = (int)$_COOKIE['tpp'];
    if (($tpp < 1) or ($tpp > 16777215)) $tpp = 20;
    if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
    $timeformat = 'H:i d.m.Y';
  }

  $query = mysqli_query($GLOBALS['DB'], 'SELECT COUNT(*) FROM claims');//подсчитываем общее количество жалоб
  $i = mysqli_fetch_row($query);
  $TotalClaims = $i[0];

  if ($TotalClaims > 0){
    $page = $_GET['page'];
    if ($page <= 0) $page = 1;   
    $TotalPages = ceil($TotalClaims / $tpp); //максимальный номер страницы = кол-во страниц
    if ($page > $TotalPages) $page = $TotalPages;
    if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка жалоб
      $ShowClaims = $TotalClaims - (($TotalPages - 1) * $tpp);
    }else{ // если страница внутри итератора - длина списка равна настроечной
      $ShowClaims = $tpp;
    }
    $Offset = $tpp * ($page - 1);
      
    $stmt = mysqli_prepare($GLOBALS['DB'],
    'SELECT claims.id_claim, claims.id_from, claims.id_to, claims.type, claims.createtime, claims.status, b1.name, b2.name, votes.vote
     FROM claims
     LEFT JOIN users AS b1 ON claims.id_from = b1.iduser
     LEFT JOIN users AS b2 ON claims.id_to = b2.iduser
     LEFT JOIN votes ON claims.id_claim = votes.id_claim AND votes.id_from=?
     WHERE claims.type=1
     UNION
     SELECT claims.id_claim, claims.id_from, claims.id_to, claims.type, claims.createtime, claims.status, b1.name, b2.name, votes.vote
     FROM claims
     LEFT JOIN users AS b1 ON claims.id_from = b1.iduser
     LEFT JOIN topics AS b2 ON claims.id_to = b2.id_topic
     LEFT JOIN votes ON claims.id_claim = votes.id_claim AND votes.id_from=?
     WHERE claims.type=2
     UNION
     SELECT claims.id_claim, claims.id_from, claims.id_to, claims.type, claims.createtime, claims.status, b1.name, b2.id_msg, votes.vote
     FROM claims
     LEFT JOIN users AS b1 ON claims.id_from = b1.iduser
     LEFT JOIN posts AS b2 ON claims.id_to = b2.id_msg
     LEFT JOIN votes ON claims.id_claim = votes.id_claim AND votes.id_from=?
     WHERE claims.type=3
     ORDER BY 6 DESC, 5 DESC
     LIMIT '."$ShowClaims".' OFFSET '."$Offset"); //берём все жалобы, сортируя от свежих к старым, и по статусу

    mysqli_stmt_bind_param($stmt, 'iii', intval($_COOKIE['iduser']), intval($_COOKIE['iduser']), intval($_COOKIE['iduser'])); 
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $id_claim, $id_from, $id_to, $type, $createtime, $status, $name, $nameto, $myvote);

    $html = '<table width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
    <tr><td><div align="center">Всего жалоб: '.$TotalClaims.'</div></td></tr><tr><td></td></tr></table>';

    if ($TotalPages > 1){ //показываем итератор, только если страниц 2 и более
      require 'PageIteratorCreate.php';
      $PageIterator = PageIteratorCreate(27, $TotalPages, $page, './?ai=40&page='); //создаём html-код итератора страниц  
      $UpperPageIterator = '<table cellpadding="0" cellspacing="0"><tr>{iterator}</tr><tr><td height="6px"></td></tr></table>';    
      $UpperPageIterator = str_replace('{iterator}', $PageIterator, $UpperPageIterator);   
    }else $UpperPageIterator='';

    $html .= $UpperPageIterator.
    '<table width="100%" cellspacing="1" cellpadding="3" style="background-color: #ffffff" border="0">
    <tr style="background-color: #d2d2d2; text-align: left; font-size: 14px; font-weight: 600">
    <td width="3%" align="middle"><img src="./pics/status.png" alt="Статус" title="Статус жалобы"></td>
    <td width="82%">Предмет жалобы</td>
    <td width="15%">Время подачи</td></tr>';  
   
    //шаблон строки таблицы
    $template = '<tr class="{class}"><td align="middle"><div>{status}</div></td>
    <td><div><a href="./?ai=41&id={id_claim}">{title}</a></div></td><td><div>{date}</div></td></tr>';

    while (mysqli_stmt_fetch($stmt)){
      $row = $template; //копируем шаблон строки

      switch ($status){
        case 'vote': 
          $row = str_replace('{status}','<img src="./pics/vote.png" alt="Vote" title="Идёт голосование...">', $row);
          break;
        case 'satisfy': 
          $row = str_replace('{status}','<img src="./pics/satisfy.png" alt="Да" title="Жалоба удовлетворена">', $row);
          break;
        case 'reject': 
          $row = str_replace('{status}','<img src="./pics/reject.png" alt="Нет" title="Жалоба отклонена">', $row);
          break;
      }   

      if (!isset($_COOKIE['iduser']) or !empty($myvote) or ($status != 'vote')) $row = str_replace('{class}','CellsOldPost', $row); //гости и голосовавшие видят жалобы "прочитанными"
      else $row = str_replace('{class}','CellsNewPost', $row); //если участник не голосовал за жалобу - она подсвечивается

      $title = $name.' против ';  
      switch ($type){
        case 1: 
          $title .= ' участника '.$nameto;
          break;
        case 2: 
          $title .= ' топика "'.$nameto.'"';
          break;
        case 3: 
          $title .= ' сообщения №'.$nameto;
          break;
      }
      $row = str_replace('{title}', $title, $row);
      $row = str_replace('{id_claim}', $id_claim, $row);

      $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
      if ($timezone < 0){
        $timeshift = abs($timezone);
        date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
      }else{
        date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
      }
      $createtime = date_format($date, $timeformat);
      $row = str_replace('{date}', $createtime, $row);

      $html .= $row;
    }
    mysqli_stmt_close($stmt);

    $LowerPageIterator='<table cellpadding="0" cellspacing="0" width="100%"><tr>
    <td width="100%"><table cellpadding="0" cellspacing="0"><tr><td height="6px"></td></tr><tr>{iterator}</tr></table></td></tr></table>';
    
    if ($TotalPages > 1){ //показываем итератор, только если страниц 2 и более
      $LowerPageIterator = str_replace('{iterator}', $PageIterator, $LowerPageIterator);
    }else{
      $LowerPageIterator = str_replace('{iterator}', '', $LowerPageIterator);   
    } 
    $html .= '</table>'.$LowerPageIterator;

    return $html;
    exit();
  }else{ //если жалоб нет
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">На форуме нет жалоб.</div></td></tr><tr><td height="10px"></td></tr></table>';  
    return $html; 
    exit();
  }
}
?>