<?php
function ShowUserPosts(){
  $id = substr($_GET['id'], 0, 5); // id участника

  $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT name, posts, deleted, avatar, status FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', intval($id));
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $authname, $Totalmsgs, $deleted, $avatar, $status);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (!$deleted and !empty($authname)){ //если такой участник есть

    if ($Totalmsgs > 0){
      require 'TagFormat.php';

      if ($GLOBALS['islogged']){ //если юзер залогинен берём его настройки отображения контента
        $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT timezone, timeformat, mpp, admin FROM users WHERE iduser=? LIMIT 1');
        mysqli_stmt_bind_param($stmt, 'i', intval($_COOKIE['iduser'])); 
        mysqli_stmt_execute($stmt);
        mysqli_stmt_bind_result($stmt, $timezone, $timeformat, $mpp, $admin);
        mysqli_stmt_fetch($stmt);
        mysqli_stmt_close($stmt);
      }else{ // если гостевой доступ
        $timezone = (int)$_COOKIE['timeshift']; // пробуем взять данные из куков
        $mpp = (int)$_COOKIE['mpp'];
        if (($mpp < 1) or ($mpp > 16777215)) $mpp = 20;
        if (($timezone < -12) or ($timezone > 12)) $timezone = 0;
        $timeformat = 'H:i d.m.Y';
      }
     
      $page = $_GET['page'];
      if ($page <= 0) $page = 1; 
      $TotalPages = ceil($Totalmsgs / $mpp); //максимальный номер страницы = кол-во страниц
      if ($page > $TotalPages) $page = $TotalPages;
      if ($page == $TotalPages){ //если страница единственная или последняя - вычисляем длину списка сообщений
        $Showmsgs = $Totalmsgs - (($TotalPages - 1) * $mpp);
      }else{ // если страница внутри итератора - длина списка равна настроечной
        $Showmsgs = $mpp;
      }
      $Offset = $mpp * ($page - 1);
    
      if ($TotalPages > 1){ //создаём итератор, только если страниц 2 и более
        require 'PageIteratorCreate.php';
        $PageIterator = PageIteratorCreate(27, $TotalPages, $page, './?ai=53&id='.$id.'&page='); //создаём html-код итератора страниц (ячейки таблицы) 
      }else $PageIterator = '';
    
      $html = '<table width="100%" style="background-color: #f5f5f5; font-size: 16px; font-weight: 600"><tr><td height="2px"></td></tr>
      <tr><td><div align="center">Сообщения участника "'.$authname.'"</div></td></tr><tr><td></td></tr></table>'; //заголовок страницы
    
      $html .= '<table cellspacing="0" cellpadding="0"><tr>'.$PageIterator.'</tr><tr><td height="2px"></td></tr></table>'; //верхний итератор
  
      $html .= '<table width="100%" cellspacing="0" cellpadding="0">
      <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; //начало таблицы сообщений
    
      //шаблон строки таблицы
      $template = '<tr><td><a name="{id_msg}"></a></td></tr><tr style="background-color: #f5f5f5">
      <td width="15%" valign="top" align="center">
        <div style="min-height: 21px"><div style="padding-top:3px">
        <a title="Перейти на страницу участника" style="font-size: 15px; font-weight: 600" href="./?ai=50&id={id}">{name}</a></div></div>
        <div style="margin-top: 5px">{avatar}</div>
        <div style="font-size: 14px" title="Статус">{status}</div>
      </td>
      <td width="85%">
        <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
        <td width="100%" align="left"><span title="Название топика" style="padding-left:6px;font-size:12px;color:#585858">{topic_name}</span></td></tr></table></div>
        <div><table width="100%" height="21px" cellspacing="0" cellpadding="0"><tr style="background: #e5e5e5">
        <td width="17%" align="middle"><span title="Время создания" style="font-size:12px;color:#585858">{createtime}</span></td>
        <td width="1%"></td>
        <td width="17%"><span title="Время правки" style="font-size: 12px;color:#585858">{edittime}</span></td>
        <td width="45%"></td>
        <td width="20%" align="right"><a title="Ссылка на сообщение" style="padding-right:4px;font-size:14px" href="./?ai=9&msg={id_msg}#{id_msg}">№{id_msg}</a></td>
        </tr></table></div>
        <div class="message">{message}</div>
        <div><table width="100%" height="26px" cellspacing="0" cellpadding="0"><tr><td align="right">{niz}</td></tr></table></div>
      </td></tr>
      <tr style="background-color: #98c6d2"><td colspan="2" height="1px"></td></tr>'; 
    
      if (!empty($avatar)) //если аватар есть - выводим его
      $template = str_replace('{avatar}','<a href="./?ai=50&id={id}"><img src="./avatars/'.$avatar.'.jpg" alt="Аватар" title="Перейти на страницу участника"></a>', $template); 
      else $template = str_replace('{avatar}','', $template);

      $niz = '';
      if ($GLOBALS['islogged']){
        if (($id == $_COOKIE['iduser'])or($admin == 1)){ //кнопку "удалить" показываем автору сообщения и админам
          $niz .= '<div style="float:right"><a class="noneall" style="cursor: pointer">'.
          '<img title="Удалить сообщение" onclick="DelMsg({id_msg})" src="./pics/delete.png" alt="Удалить"></a></div>';
        }
        
        if ($id == $_COOKIE['iduser']){
          $niz .= '<div style="float:right"><a class="noneall" href="./?ai=11&id={id_msg}" style="cursor: pointer"><img title="Правка" src="./pics/edit.png" alt="Правка"></a></div>';
        }
      }
  
      $template = str_replace('{id}',$id, $template);
      $template = str_replace('{status}',$status, $template);
      $template = str_replace('{niz}', $niz.'{likes}', $template);
      $template = str_replace('{name}',$authname, $template);

      $stmt = mysqli_prepare($GLOBALS['DB'],
      'SELECT posts.id_msg, posts.createtime, posts.edittime, posts.text, posts.likes, posts.disagrees, topics.name FROM posts
       LEFT JOIN topics ON posts.id_topic = topics.id_topic
       WHERE posts.id_author=? AND posts.deleted=0
       ORDER BY posts.id_msg ASC
       LIMIT '."$Showmsgs".' OFFSET '."$Offset"); //берём все сообщения участника, сортируя от свежих к старым
      mysqli_stmt_bind_param($stmt, 'i', intval($id));
      mysqli_stmt_execute($stmt);
      mysqli_stmt_bind_result($stmt, $id_msg, $createtime, $edittime, $text, $likes, $disagrees, $topic_name);
    
      while (mysqli_stmt_fetch($stmt)){
        $row = $template; //копируем шаблон строки
    
        $row = str_replace('{id_msg}',$id_msg, $row);
      
        $date = date_create($createtime); //для отображения смещаем время на указанное в настройках количество часов
        if ($timezone < 0){
          $timeshift = abs($timezone);
          date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
        }else{
          date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
        }
        $createtime = date_format($date, $timeformat);
        $row = str_replace('{createtime}',$createtime, $row);
    
        if ($edittime != '0000-00-00 00:00:00'){
          $date = date_create($edittime); //для отображения смещаем время на указанное в настройках количество часов
          if ($timezone < 0){
            $timeshift = abs($timezone);
            date_sub($date, date_interval_create_from_date_string("$timeshift".' hours'));
          }else{
            date_add($date, date_interval_create_from_date_string("$timezone".' hours'));
          }
          $edittime = date_format($date, $timeformat);
          $row = str_replace('{edittime}',$edittime, $row);
        }else{
          $row = str_replace('{edittime}','', $row);
        }

        if ($likes>0) $pref1 = '+'; //лайки показываем всем и всегда
        else $pref1 = '';
        if ($disagrees>0) $pref2 = '-';
        else $pref2 = '';
        $nizlikes ='<div style="float:right;margin-top:5px;padding-left:5px;padding-right:5px;">
        <span id="SL'.$id_msg.'" onmouseover="ShowLikes('.$id_msg.')" style="color:blue">'.$pref1.$likes.
        '</span> | <span id="SD'.$id_msg.'" onmouseover="ShowDislikes('.$id_msg.')" style="color:red">'.$pref2.$disagrees.'</span></div>';
        $row = str_replace('{likes}',$nizlikes, $row);
        $row = str_replace('{topic_name}', $topic_name, $row); 
          
        $row = str_replace('{message}', TagFormat($text), $row); //выводим имя и сообщение со всеми тэгами в конце, чтобы исключить риски замены данных в тексте сообщения
    
        $html .= $row;
      }
      mysqli_stmt_close($stmt);
    
      $html .= '<script>function DelMsg(idmsg){if(confirm("Вы уверены, что хотите удалить данное сообщение?")){var data="ai=8&id="+encodeURIComponent(idmsg);AsyncAct(data);}}
      function ShowLikes(idmsg){var data="ai=10&id=0&msg="+encodeURIComponent(idmsg);AsyncAct(data);}
      function ShowDislikes(idmsg){var data="ai=10&id=1&msg="+encodeURIComponent(idmsg);AsyncAct(data);}
      </script></table><table cellspacing="0" cellpadding="0"><tr><td height="3px"></td></tr><tr>'.$PageIterator.'</tr><tr><td height="2px"></td></tr></table>';//нижний итератор

    }else{ //если сообщений нет
      $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">У "'.$authname.'" нет сообщений.</div></td></tr><tr><td height="10px"></td></tr></table>'; 
    }
  }else{ //если такого участника нет
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">Такого участника нет.</div></td></tr><tr><td height="10px"></td></tr></table>';
  }

  return $html;
}
?>