<?php
require 'const.php';
session_start();

if (!isset($_POST['topic']) or //если что-то отсутствует, запускаем форму создания топика
    !isset($_POST['message']) or
    !isset($_POST['topictype']))
{
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=8');
  else header('Location: http://'.$HostName.'/?ai=8');
  exit();
}

if (!isset($_COOKIE['iduser']) or !isset($_COOKIE['hash'])){ //если юзер не авторизован то перенаправляем на начальную страницу
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
  else header('Location: http://'.$HostName);
  exit();
}
$iduser = intval($_COOKIE['iduser']);

$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname);

  $stmt = mysqli_prepare($DB, 'SELECT status, deleted, user_hash FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', $iduser);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $status, $deleted, $user_hash);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if ($user_hash !== $_COOKIE['hash']){ //если хэши не совпадают
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName']);
    else header('Location: http://'.$GLOBALS['HostName']);
    exit();
  } 

  if (($status != 'create') or ($deleted == 1)){
    $_SESSION['msg'] = 'Ваш статус не позволяет создавать топики.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
    exit();
  }

//обрезаем переменные по длине и проверяем все ошибки
  $error = '';
  $topic = substr($_POST['topic'], 0, 300);
  $topic = trim($topic);
  $topictype = $_POST['topictype'];
  if ($topictype > 1) $topictype = 2; // может быть 2 типа топиков 1 - открытый для всех, 2 - закрытый
  else $topictype = 1;
  $message = $_POST['message'];
  $testmsg = trim($message);
  
  if (empty($topic)) $error .= '<li>Название топика не может быть пустым</li>'."\n";
  if (empty($testmsg)) $error .= '<li>Текст сообщения не может быть пустым</li>'."\n";
  if (strlen($message)>100000) $error .= '<li>Текст сообщения не может превышать 50000 символов</li>'."\n";
  if (strlen($topic)>300) $error .= '<li>Название топика не может превышать 150 символов</li>'."\n";

  //проверка на создание второго топика в сутки
  $now = date('Y-m-d H:i:s');
  $date = date_create($now);
  date_sub($date, date_interval_create_from_date_string('1 day')); //вычитаем один день из текущего времени
  $comptime = date_format($date, 'Y-m-d H:i:s');

  $stmt = mysqli_prepare($DB, "SELECT id_topic FROM topics WHERE id_author=? AND createtime <='".$now."' AND createtime >= '".$comptime."'");
  mysqli_stmt_bind_param($stmt, 'i', $iduser);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_store_result($stmt);
  $num = mysqli_stmt_num_rows($stmt);
  mysqli_stmt_close($stmt);
  if ($num > 2) $error .= '<li>В сутки можно создавать не более трёх топиков</li>'."\n"; //закоментить/откоментить для вкл/выкл данного функционала
  
  // Если есть хотя бы одна ошибка - сохраняем в глобальном массиве введённые поля и снова запускаем форму
  if (!empty($error)){
    $_SESSION['NewTopicForm'] = array();
    $_SESSION['NewTopicForm']['error'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    $_SESSION['NewTopicForm']['topic'] = $topic;
    $_SESSION['NewTopicForm']['message'] = $message;
    $_SESSION['NewTopicForm']['topictype'] = $topictype; 

    mysqli_close($DB);
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=8');
    else header('Location: http://'.$HostName.'/?ai=8');
    exit();
  }
 
  // если все поля заполнены правильно - создаём новый топик
  $createtime = date('Y-m-d H:i:s');
  $stmt = mysqli_prepare($DB, "INSERT INTO topics SET type=?, id_author=?, id_lastuser=?, name=?, createtime=?, lasttime=?");
  mysqli_stmt_bind_param($stmt, 'iiisss', $topictype, $iduser, $iduser, $topic, $createtime, $createtime);
  mysqli_stmt_execute($stmt);
  $dber = mysqli_stmt_error($stmt);
  mysqli_stmt_close($stmt);
  $id_topic = mysqli_insert_id($DB); //id нового топика

  if (empty($dber)){    
    // создаём новое сообщение для этого топика
    $stmt = mysqli_prepare($DB, 'INSERT INTO posts SET id_author=?, id_topic=?, text=?, createtime=?');
    mysqli_stmt_bind_param($stmt, 'iiss', $iduser, $id_topic, $message, $createtime);
    mysqli_stmt_execute($stmt);
    $dber2 = mysqli_stmt_error($stmt);
    mysqli_stmt_close($stmt);
    $id_post = mysqli_insert_id($DB); //id нового поста

    if (empty($dber2)){
      $stmt = mysqli_prepare($DB, 'UPDATE users SET topics = topics + 1, posts = posts + 1 WHERE iduser=?'); //обновляем данные участника
      mysqli_stmt_bind_param($stmt, 'i', $iduser);
      mysqli_stmt_execute($stmt);
      $dber3 = mysqli_stmt_error($stmt);
      mysqli_stmt_close($stmt);

      mysqli_query($DB, 'UPDATE topics SET id_lastmsg='.$id_post.' WHERE id_topic='.$id_topic); //заносим последнее сообщение в топик
      $dber4 = mysqli_error($DB);

      $stmt = mysqli_prepare($DB, 'INSERT INTO newmsgs (id_topic, iduser) SELECT '."$id_topic".', iduser FROM users');
      mysqli_stmt_execute($stmt);   //записываем маркеры непрочитанных сообщений для всех участников
      mysqli_stmt_close($stmt);
    }
  }
  mysqli_close($DB);

  if (empty($dber) and empty($dber2) and empty($dber3) and empty($dber4)){
    //переходим в созданный топик
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=9&id='."$id_topic");
    else header('Location: http://'.$HostName.'/?ai=9&id='."$id_topic");
  }else{
    $_SESSION['msg'] = 'Ошибка базы данных: '.$dber.' '.$dber2.' '.$dber3.' '.$dber4;
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
  }
}else{
  $_SESSION['msg'] = 'Ошибка соединения с базой данных: '.mysqli_connect_error();
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
  else header('Location: http://'.$HostName.'/?ai=200');
}
?>