<?php
function TrySendTelegram()
{
  if (!$GLOBALS['islogged'] or !isset($_COOKIE['iduser']) or !isset($_COOKIE['hash'])){ //если юзер не авторизован, то  перенаправляем на начальную страницу
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName']);
    else header('Location: http://'.$GLOBALS['HostName']);
    exit();
  }

  if (!isset($_POST['phone'])){ //если ID отсутствует, то запускаем форму
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=6');
    else header('Location: http://'.$GLOBALS['HostName'].'/?ai=6');
    exit();
  }

  $phone = substr($_POST['phone'], 0, 20); //обрезаем переменную по длине
  $phone = preg_replace('/[^0-9]/', '', $phone); // удаляем всё кроме цифр

  // Проверяем все ошибки
  $error = '';
  if (empty($phone)) $error .= '<li>ID не может быть пустым</li>'."\n";

  // проверка на повторное использование ID
  $phonemd5 = md5(md5("$phone")); //в базе хранятся только двойные хэши
  $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT iduser FROM users WHERE phone=? AND smscode=1'); //ищем только активированных участников
  mysqli_stmt_bind_param($stmt, 's', $phonemd5);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_store_result($stmt);
  $num = mysqli_stmt_num_rows($stmt);
  mysqli_stmt_close($stmt);
  if ($num > 0) $error .= '<li>Этот ID уже использован для активации</li>'."\n";

  // проверка на попытку повторной активации, также заодно достаём из базы IP
  $stmt = mysqli_prepare($GLOBALS['DB'], 'SELECT smscode, user_ip FROM users WHERE user_hash=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 's', $_COOKIE['hash']);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $codeDB, $user_ip);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);
  if ($codeDB == '1') $error .= '<li>Учётная запись уже активирована</li>'."\n";

   // если есть хотя бы одно отклонение от нормы, снова запускаем форму но с сообщением
  if (!empty($error)){
    $_SESSION['SMSActFormError'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$GLOBALS['HostName'].'/?ai=6');
      else header('Location: http://'.$GLOBALS['HostName'].'/?ai=6');
    exit();
  }
  
  // код активации для отправки по Telegram
  $ALLOWED_CHARS = '0123456789';
  $code = '';
  mt_srand(hrtime()[1]);
  for ($i = 0; $i < 6; $i++){
  $char = substr($ALLOWED_CHARS, mt_rand(0, strlen($ALLOWED_CHARS) - 1), 1);   
  $code .= $char;}// сохраняем накопительно код 

  $stmt = mysqli_prepare($GLOBALS['DB'], 'UPDATE users SET smscode=?, phone=? WHERE user_hash=?');
  mysqli_stmt_bind_param($stmt, 'sss', $code, $phonemd5, $_COOKIE['hash']);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_close($stmt);
 
  $botToken = ''; //токен бота
  $sendMessageUrl = 'https://api.telegram.org/bot'.$botToken.'/sendMessage?chat_id='.$phone.'&text=Code: '.$code;
  $response = file_get_contents($sendMessageUrl); // отправляем код в телеграм

  if ($response === FALSE) {
    $error = error_get_last(); // Получаем последнюю ошибку PHP
    $html = '<table width="100%" style="background-color: #f5f5f5"><tr><td height="10px"></td></tr>
    <tr><td><div align="center">Произошла ошибка'.$error['message'].'<br>Попробуйте активацию позже.</div></td></tr><tr><td height="10px"></td></tr></table>';
  } else {
    $html = file_get_contents('./templates/activateForm.html'); //загружаем шаблон формы активации   
    $html = str_replace('{iduser}', '', $html);
    $html = str_replace('{action}', 'TryActivateTelegram.php', $html);
    $html = str_replace('{error}', '', $html);
    $html = str_replace('{text}', '<br>Для активации учётной записи введите код, отправленный Вам по Telegram.', $html);
  }
 return $html;
}
?>