<?php
require 'const.php';
session_start();

if (!isset($_POST['id_topic']) or //если что-то отсутствует либо юзер неавторизован, запускаем заглавную страницу
    !isset($_POST['topic']) or  
    !isset($_POST['topictype']) or
    !isset($_COOKIE['iduser']) or
    !isset($_COOKIE['hash']))
{
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
  else header('Location: http://'.$HostName);
  exit();
}

$iduser = intval($_COOKIE['iduser']);
$id_topic = (int)substr(strval($_POST['id_topic']), 0, 6);

$DB = mysqli_connect($DBhost, $DBuser, $DBpwd);
if ($DB !== false){
  mysqli_select_db($DB, $DBname);

  $stmt = mysqli_prepare($DB, 'SELECT user_hash FROM users WHERE iduser=? LIMIT 1');
  mysqli_stmt_bind_param($stmt, 'i', $iduser);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $user_hash);
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if ($user_hash !== $_COOKIE['hash']){ //если хэши не совпадают
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName);
    else header('Location: http://'.$HostName);
    exit();
  }

  $stmt = mysqli_prepare($DB, 'SELECT id_author FROM topics WHERE id_topic=? LIMIT 1'); //проверяем есть ли топик и его автор
  mysqli_stmt_bind_param($stmt, 'i', $id_topic);
  mysqli_stmt_execute($stmt);
  mysqli_stmt_bind_result($stmt, $id_author); 
  mysqli_stmt_fetch($stmt);
  mysqli_stmt_close($stmt);

  if (!isset($id_author)){
    $_SESSION['msg'] = 'Такого топика нет.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
    exit();
  }

  if ($id_author != $iduser){
    $_SESSION['msg'] = 'Нельзя редактировать чужие топики.';
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');  
    exit();
  }

//обрезаем переменные по длине и проверяем все ошибки
  $error = '';
  $topic = substr($_POST['topic'], 0, 300);
  $topic = trim($topic);
  $topictype = $_POST['topictype'];
  if ($topictype > 1) $topictype = 2; // может быть 2 типа топиков 1 - открытый для всех, 2 - закрытый
  else $topictype = 1;
  if (empty($topic)) $error .= '<li>Название топика не может быть пустым</li>'."\n";
  if (strlen($topic)>300) $error .= '<li>Название топика не может превышать 150 символов</li>'."\n";
  
  // Если есть хотя бы одна ошибка - сохраняем в глобальном массиве введённые поля и снова запускаем форму
  if (!empty($error)){
    $_SESSION['EditTopicForm'] = array();
    $_SESSION['EditTopicForm']['error'] = 'Были допущены ошибки:'."\n".'<ul>'."\n".$error.'</ul>'."\n";
    $_SESSION['EditTopicForm']['topic'] = $topic;
    $_SESSION['EditTopicForm']['topictype'] = $topictype; 

    mysqli_close($DB);
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=12&id='."$id_topic");
    else header('Location: http://'.$HostName.'/?ai=12&id='."$id_topic");
    exit();
  }
 
  // если все поля заполнены правильно - обновляем топик
  $stmt = mysqli_prepare($DB, 'UPDATE topics SET type=?, name=?  WHERE id_topic=?');
  mysqli_stmt_bind_param($stmt, 'isi', $topictype, $topic, $id_topic);
  mysqli_stmt_execute($stmt);
  $dber = mysqli_stmt_error($stmt);
  mysqli_stmt_close($stmt);

  mysqli_close($DB);

  if (empty($dber)){
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=9&id='."$id_topic");//переходим в отредактированный топик
    else header('Location: http://'.$HostName.'/?ai=9&id='."$id_topic");
  }else{
    $_SESSION['msg'] = 'Ошибка базы данных: '.$dber;
    if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
    else header('Location: http://'.$HostName.'/?ai=200');
  }
}else{
  $_SESSION['msg'] = 'Ошибка соединения с базой данных: '.mysqli_connect_error();
  if (isset($_SERVER['HTTPS'])) header('Location: https://'.$HostName.'/?ai=200');
  else header('Location: http://'.$HostName.'/?ai=200');
}
?>