<?php
mt_srand(hrtime()[1]); //Инициализируем генератор случайных чисел.
$fonts = array('liber-mono.ttf', 'liber-sans.ttf');//из этого списка каждый раз будем выбирать случайный шрифт
$par = array(
	'WIDTH' => 120,// ширина капчи	
	'HEIGHT' => 32,// высота капчи
	'FONT_SIZE' => 16,// размер шрифта на капче
	'CHARS_COUNT' => 5,// кол-во символов на капче	
	'ALLOWED_CHARS' => 'ABCDEFGHJKLMNPQRSTUVWXYZ23458',// разрешенные символы капчи	
	'BG_COLOR' => '#FFFFFF',// фоновый цвет капчи	
	'LINES_COUNT' => 3,// кол-во линий на капче	
	'LINES_THICKNESS' => 2// толщина линий
);
define('CODE_CHAR_COLORS', '#880000,#008800,#000088,#888800,#880088,#008888,#000000');// цвета символов
define('CODE_LINE_COLORS', '#880000,#008800,#000088,#888800,#880088,#008888,#000000');// цвета линий

$line_colors = preg_split('/,\s*?/', CODE_LINE_COLORS);// получаем цвета линий и символов в массивы для случайной выборки позднее
$char_colors = preg_split('/,\s*?/', CODE_CHAR_COLORS);

// создаем пустой рисунок и заливаем его фоновым цветом
$img = imagecreatetruecolor($par['WIDTH'], $par['HEIGHT']);
imagefilledrectangle($img, 0, 0, $par['WIDTH'] - 1, $par['HEIGHT'] - 1, gd_color($par['BG_COLOR']));

$code = '';// Переменная для хранения кода капчи

$y = ($par['HEIGHT']/2) + ($par['FONT_SIZE']/2);// Зададим координату по центру оси Y 

for ($i = 0; $i < $par['CHARS_COUNT']; $i++) {// Выводим символы на капче
    $color = gd_color($char_colors[mt_rand(0, count($char_colors) - 1)]);// выбираем случайный цвет из доступного набора
    $angle = mt_rand(-30, 30);// определяем случайный угол наклона символа 
    $char = substr($par['ALLOWED_CHARS'], mt_rand(0, strlen($par['ALLOWED_CHARS']) - 1), 1);// выбираем случайный символ из доступного набора   
    $font = './pics/'.$fonts[mt_rand(0, count($fonts) - 1)];// выбираем случайный шрифт из доступного набора   
    $x = (intval(($par['WIDTH'] / $par['CHARS_COUNT']) * $i) + ($par['FONT_SIZE'] / 2)); // вычисляем координату текущего символа по оси X    
    imagettftext($img, $par['FONT_SIZE'], $angle, $x, $y, $color, $font, $char);// выводим символ на капчу   
    $code .= $char;// сохраняем накопительно код капчи
}

function gd_color($html_color)// Преобразуем HTML 6-символьный цвет в GD цвет 
{
  return preg_match('/^#?([\dA-F]{6})$/i', $html_color, $rgb)
	? hexdec($rgb[1]) : false;
}

imagesetthickness($img, $par['LINES_THICKNESS']);// выводим на капчу линии
for ($i = 0; $i < $par['LINES_COUNT']; $i++)
    imageline($img,
        mt_rand(0, $par['WIDTH'] - 1),
        mt_rand(0, $par['HEIGHT'] - 1),
        mt_rand(0, $par['WIDTH'] - 1),
        mt_rand(0, $par['HEIGHT'] - 1),
        gd_color($line_colors[mt_rand(0, count($line_colors) - 1)])
    );

setcookie('imgcaptcha', md5($code),0,'/');// сохраняем зашифрованную капчу в куках для дальнейшей проверки
header('Content-Type: image/png');//Посылаем сформированный рисунок в браузер и удаляем его
imagepng($img);
imagedestroy($img);
?>